% Realimentao de estado com integrador

% Seja a planta discreta
Phi   = [0.7 -0.3 ; 0.1 0.5];
Gamma = eye(2);
C     = eye(2);
D     = zeros(2,2);
T     = 0.1
S = ss(Phi,Gamma,C,D,T);


% Polos desejados
qsi = 0.9021;
wn  = 10.726;
sc  = roots([1 2*qsi*wn wn^2]);
zc  = exp(sc*T);

% Integrador
zi = [exp(-T/1) ; exp(-T/0.5)];


% Sistema aumentado
Phi_bar   = [ Phi zeros(2) ; -T*C eye(2) ];
Gamma_bar = [ Gamma ; zeros(2) ];

K_bar = place(Phi_bar, Gamma_bar, [zc;zi])
K  = K_bar(1:2,1:2)
Ki = -K_bar(1:2,3:4)

% Pr filtro (como no caso anterior)
F   = inv([ (Phi-eye(2)) Gamma ; C zeros(2) ])*[ zeros(2) ; eye(2) ];
Fxl = F(1:2,1:2)

% Integrador
Si = ss(eye(2),T*eye(2),eye(2),zeros(2),T);

% Simulao
sim('ex_sf_ff_int_sim');

% Grfico
figure(1)
clf
stairs(tsim,xsim,'-o')
hold on
stairs(tsim,xrsim(:,1),'-b','linewidth',1.5)
stairs(tsim,xrsim(:,2),'-r','linewidth',1.5)
axis([0 15 0 1.2])
grid
legend('x_{1}(t)','x_{2}(t)','location','southeast')
xlabel('t (s)')
ylabel('x(t)')
title('Resposta ao degrau da malha fechada com integrador')
hold off
